(require 'navi2ch)
(require 'my-navi2ch-article-info)

;;; $B%f!<%6!<JQ?t(B
(defvar my-navi2ch-patrol-ignore-bookmark nil
  "$BL5;k$9$k(B global bookmark $B$N(B id $B$N%j%9%H(B($B@55,I=8=2DG=(B)")

(defvar my-navi2ch-patrol-check-board t
  "$B%9%l$r99?7$9$kA0$K%9%l$NB0$9$kHD$r99?7$9$k$+!#(B
t $B$J$i99?7$9$k(B
nil $B$J$i99?7$7$J$$(B
$B?tCM$J$i!"99?7BP>]$H$J$kHD$KB0$9$k%9%l$,?tCM0J>e(B
global bookmark $B$KEPO?$5$l$F$$$k>l9g$KHD>pJs$r99?7$9$k!#(B")

(defvar my-navi2ch-patrol-apply-board nil
  "$BHD$KBP$9$k@_Dj!#(B
$B@_DjNc(B:
'((ignore nil)
  (new-article nil)
  (\"unix\" (ignore nil) (new-article nil) ; unix $BHD$r99?7$7(B,
                                             ; $B?7%9%l$r%A%'%C%/$7$J$$(B
  (\"shar\" (ignore nil) (new-article \"hoge\")
       ; $BHD$r99?7$7!"?7%9%l$O(B hoge $B$KDI2C$9$k!#(B
  (\"linux\" (ignore t)))) ; linux $BHD$r99?7$7$J$$(B ")

(defvar my-navi2ch-patrol-new-articles-id nil
  "$B?7%9%l$rEPO?$9$k(B global bookmark ID")
(defvar my-navi2ch-patrol-update-articles-id nil
  "$B99?7$7$?%9%l$rEPO?$9$k(B global bookmark ID")

(defvar my-navi2ch-patrol-new-article-max-line 50
  "$B?7%9%l$rJ];}$9$k7o?t(B")

(defvar my-navi2ch-patrol-old-update-articles-clear-p nil
  "\"U\" $B%^!<%/$,$D$$$F$$$k$,!":#2s$N(B \\[my-navi2ch-patrol] $B$N<B9T$G(B
$B99?7$5$l$F$$$J$$>l9g$K!"(B`my-navi2ch-patrol-update-articles-id' $B$N(B
$B%V%C%/%^!<%/$+$i:o=|$9$k$+(B")

(defvar my-navi2ch-patrol-goto-update-articles-bookmark-p t
  "\\[my-navi2ch-patrol] $B$N=*N;;~$K(B
`my-navi2ch-patrol-update-articles-id' $B$X0\F0$9$k$+(B")



(defvar my-navi2ch-patrol-after-hook nil
  "$B=*N;(B hook")


;;; $BFbItJQ?t(B
(defvar my-navi2ch-patrol-fetched-article-list nil
  "$B:#2s$N=d2s$G<hF@$7$?%9%l$N%j%9%H(B")

(defvar my-navi2ch-patrol-alist-internal nil
  "$B=d2sBP>]$H$9$kHD$HHD$KBP$9$k=hM}$N(B alist")

(defvar my-navi2ch-patrol-bookmark-save-info-p nil
  "bookmark $B$r(B save $B$9$kI,MW$,$"$k$+(B")

(defvar my-navi2ch-patrol-error-host-list nil
  "$B@\B3ITG=$J(B (host$BL>(B . $B<:GT2s?t(B)  $B$N%j%9%H(B")

(defvar my-navi2ch-patrol-error-host-retry-max 6
  "$B<+F0=d2sCf$K2?2s$^$G!"F10l$N%[%9%H$KBP$7@\B3%(%i!<$r5v$9$+(B")

(defvar my-navi2ch-patrol-checked-board-list nil
  "check $B$7$?HD$N%j%9%H(B (debug $BMQ(B)")


;;; $B4X?tDj5A(B
(defun my-navi2ch-patrol-make-alist-subr ()
  "`my-navi2ch-patrol-apply-board' $B$r85$K=d2sBP>]$H$9$kHD$H$=$l$KBP$9$k=hM}$N(B
alist $B$r:n$k(B"
  (let ((slot my-navi2ch-patrol-apply-board))
    (when slot
      (let* ((handling (or (assoc 'handling slot)
			   '(handling nil)))
	     (new-article (or (assoc 'new-article slot)
					;							  '(:new-article nil)))
			      `(new-article
				,my-navi2ch-patrol-new-articles-id)))
	     (ignore (or (assoc 'ignore slot)
			 '(ignore nil)))
	     (list
	      (delq nil
		    (mapcar
		     (lambda (x)
		       (cond ((stringp x)
			      (list x handling new-article ignore))
			     ((and (listp x) (stringp (car x)))
			      (or (assoc 'handling x)
				  (setq x (append x (list handling))))
			      (or (assoc 'new-article x)
				  (setq x (append x (list new-article))))
			      (or (assoc 'ignore x)
				  (setq x (append x (list ignore))))
			      x)
			     (t nil))) slot))))
	list))))

(defun my-navi2ch-patrol-bookmark-mark-maybe-new-articles-subr ()
  "point $B>e$N%9%l$,99?7$5$l$F$$$k2DG=@-$N$"$k>l9g%^!<%/$rIU$1$k(B"
  (let* ((item (navi2ch-bm-get-property-internal (point)))
	 (board (navi2ch-bm-get-board-internal item))
	 (article (navi2ch-bm-get-article-internal item))
	 (uri (concat (cdr (assoc 'uri board))
		      (cdr (assoc 'artid article))))
	 (info (my-navi2ch-article-info-get-info item))
	 (kako (or (and (cdr (assoc 'kako info)) 'kako)
		   (cdr (assoc 'moved info))))
	 (board-id (cdr (assoc 'id board)))
	 (cache (navi2ch-article-check-cached board article))
	 (artid (assoc 'artid article))
	 (article-dat
	  (assoc artid
		 (cdr
		  (cdr
		   (assoc board-id
			  my-navi2ch-article-info-global-bookmark-alist)))))
	 (update (assoc 'update article-dat)))
    (when (and article-dat (not (and cache (or kako (cdr update)))))
      (if update
	  (setcdr update t)
	(setcdr article-dat (cons '(update . update) (cdr article-dat))))
      ;; $B99?7%9%l$r(B my-navi2ch-patrol-fetched-article-list $B$KDI2C(B
      (and uri board article
	   (setq my-navi2ch-patrol-fetched-article-list
		 (cons
		  (list uri board article)
		  my-navi2ch-patrol-fetched-article-list)))
      (navi2ch-bm-mark-subr "*"))))

(defun my-navi2ch-patrol-bookmark-mark-maybe-new-articles ()
  "bookmark $B>e$G99?7$5$l$F$$$k2DG=@-$N$"$k%9%l$K%^!<%/$rIU$1$k(B"
  (save-excursion
    (goto-char (point-min))
    (while (not (eobp))
      (my-navi2ch-patrol-bookmark-mark-maybe-new-articles-subr)
      (forward-line))))

(defun my-navi2ch-patrol-fetch-maybe-new-articles ()
  "$B99?7$7$?2DG=@-$N$"$k%9%l$r<hF@$9$k(B"
  (my-navi2ch-patrol-bookmark-mark-maybe-new-articles)
  (sit-for 0)
  (navi2ch-bookmark-fetch-mark-article))

(defun my-navi2ch-patrol-make-alist (&optional target)
  "`my-navi2ch-patrol-ignore-bookmark'
`my-navi2ch-patrol-check-board'
`my-navi2ch-article-info-global-bookmark-alist'
$B0J>e$r85$K=d2sBP>]$H$9$kHD$H$=$l$KBP$9$k=hM}$N(B
alist $B$r:n$k(B"
  (let* ((ignore
	  (my-navi2ch-patrol-make-ignore-id-regexp
	   (if (not target)
	       my-navi2ch-patrol-ignore-bookmark
	     (mapcar (lambda (x)
		       (concat "\\`" x "\\'"))
		     (my-navi2ch-patrol-make-ignore-bookmark target)))))
	 (new-article `(new-article ,my-navi2ch-patrol-new-articles-id))
	 (handling '(handling my-navi2ch-patrol-fetch-maybe-new-articles))
	 (check-board my-navi2ch-patrol-check-board)
	 (bookmark-list
	  (delq nil
		(mapcar
		 (lambda (x)
		   (let ((name (cdr (assq 'id x))))
		     (if (and (stringp ignore)
			      (string-match ignore name))
			 nil name)))
		 (navi2ch-list-get-global-bookmark-board-list))))
	 (id-list
	  (delq nil
		(mapcar
		 (lambda (x)
		   (cond
		    ((not my-navi2ch-patrol-check-board)
		     nil)
		    ((numberp my-navi2ch-patrol-check-board)
		     (if (>= (length (cdr (cdr x)))
			     my-navi2ch-patrol-check-board)
			 (car x) nil))
		    (t (car x))))
		 (if target
		     (my-navi2ch-patrol-global-bookmark-alist-setup target)
		   my-navi2ch-article-info-global-bookmark-alist))))
	 (tmp-list (my-navi2ch-patrol-make-alist-subr))
	 board-list)
    (while id-list
      (let ((slot (assoc (car id-list) tmp-list)))
	(if slot
	    (when target
	      (setq board-list
		    (cons slot board-list)))
	  (setq board-list (cons
			    (list (car id-list) '(ignore nil)
				  new-article)
			    board-list))))
      (setq id-list (cdr id-list)))
    (append
     (unless target tmp-list) board-list
     (mapcar (lambda (x) (list x handling)) bookmark-list))))

(defun my-navi2ch-patrol-make-ignore-id-regexp (lst)
  "$B=d2sBP>]$+$i30$9HD(B ID $B$N@55,I=8=$r:n$k(B"
  (mapconcat
   'identity
   (delq nil
	 (append lst
		 (mapcar (lambda (x)
			   (concat "\\`" x "\\'"))
			 (my-navi2ch-patrol-make-ignore-bookmark))))
   "\\|"))

(defun my-navi2ch-patrol-add-bookmark-update-articles ()
  "$B99?7$7$?%9%l$r(B `my-navi2ch-patrol-update-articles-id' $B$G(B
$B;XDj$5$l$?(B global bookmark $B$KDI2C$9$k(B"
  (when my-navi2ch-patrol-update-articles-id
    (let* ((bl (cdr (assoc my-navi2ch-patrol-update-articles-id
			   navi2ch-bookmark-list)))
	   (fetched-list my-navi2ch-patrol-fetched-article-list)
	   (bl_tmp (delq nil
			 (mapcar
			  (lambda (x)
			    (if (assoc (car x) fetched-list) nil x))
			  (cdr bl)))))
      (setcdr bl nil)
      (mapcar (lambda (x)
		(when (navi2ch-bm-fetched-article-p (nth 1 x) (nth 2 x))
		  (my-navi2ch-patrol-bookmark-add-subr
		   my-navi2ch-patrol-update-articles-id (nth 1 x) (nth 2 x))))
	      (if my-navi2ch-patrol-old-update-articles-clear-p
		  fetched-list
		(append (reverse bl_tmp) fetched-list))))))

(defun my-navi2ch-patrol-make-ignore-bookmark (&optional target)
  "$B0z?t$G;XDj$5$l$?$b$N0J30$N(B global bookmark id $B$N%j%9%H$rJV$9!#(B
$B0z?t$,(B nil $B$N>l9g$O!"99?7MQ!"?7%9%lMQ$N(B bookmark $B$N%j%9%H$rJV$9!#(B"
  (if target
      (let ((lst (copy-sequence (mapcar 'car navi2ch-bookmark-list))))
	(or (listp target)
	    (setq target (list target)))
	(while target
	  (setq lst (delete (car target) lst))
	  (setq target (cdr target)))
	lst)
    (delq nil
	  (append (list my-navi2ch-patrol-update-articles-id
			my-navi2ch-patrol-new-articles-id)
		  (let ((lst (my-navi2ch-patrol-make-alist-subr))
			arg rtn)
		    (while (setq arg (car lst))
		      (let ((new-article (car (cdr (assoc 'new-article arg)))))
			(when (and (stringp new-article)
				   (not (member new-article rtn)))
			  (setq rtn (cons new-article rtn))))
		      (setq lst (cdr lst)))
		    rtn)))))

(defun my-navi2ch-patrol-read-bookmark-id ()
  "mini-buffer $B$+$i(B global bookmark id $B$rFI$_<h$k(B"
  (let* ((ignore (my-navi2ch-patrol-make-ignore-bookmark))
	 (id navi2ch-bookmark-current-bookmark-id)
	 (lst (copy-sequence (mapcar 'car navi2ch-bookmark-list)))
	 (prompt
	  (format "input global bookmark-id%s: "
		  (if navi2ch-bookmark-current-bookmark-id
		      (concat " (default["
			      navi2ch-bookmark-current-bookmark-id "])")
		    ""))))
    (while ignore
      (setq lst (delete (car ignore) lst))
      (setq ignore (cdr ignore)))
    (let ((arg (completing-read
		prompt (mapcar 'list lst) nil t nil nil
		navi2ch-bookmark-current-bookmark-id)))
      (if (string= arg "") nil arg))))

(defun my-navi2ch-patrol-add-bookmark-new-articles (arg)
  "$B%9%l0lMw$G?75,%^!<%/(B (%) $B$NIU$$$?%9%l$rI,MW$J$i(B
`my-navi2ch-patrol-new-articles-id' $B$G;XDj$5$l$?(B global bookmark $B$KDI2C$9$k(B"
  (let ((bookmark-id (if (stringp arg)
			 arg
		       (and arg my-navi2ch-patrol-new-articles-id))))
    (when (and bookmark-id
	       (member bookmark-id
		       (mapcar
			(lambda (x) (cdr (assq 'id x)))
			(navi2ch-list-get-global-bookmark-board-list))))
      (save-excursion
	(goto-char (point-min))
	(while (not (eobp))
	  (navi2ch-bm-goto-updated-mark-column)
	  (when (looking-at "%")
	    (let* ((item (navi2ch-bm-get-property-internal (point)))
		   (board (navi2ch-bm-get-board-internal item))
		   (article (navi2ch-bm-get-article-internal item)))
	      (if item
		  (my-navi2ch-patrol-bookmark-add-subr
		   bookmark-id board article))))
	  (forward-line))))
    bookmark-id))

(defun my-navi2ch-patrol-trim-new-article (bookmark-list)
  "$BI,MW$K1~$8$F!"(Bbookmark $B$N%9%l$r@Z$j5M$a$k(B"
  (let ((bl bookmark-list))
    (while bl
      (let ((l (cdr (cdr (assoc (car bl)
				navi2ch-bookmark-list)))))
	(when (and my-navi2ch-patrol-new-article-max-line
		   (> (length l) my-navi2ch-patrol-new-article-max-line))
	  (setcdr (nthcdr (1- my-navi2ch-patrol-new-article-max-line) l) nil)))
      (setq bl (cdr bl)))))

(defun my-navi2ch-patrol-global-bookmark-alist-setup (&optional target)
  "`my-navi2ch-article-info-global-bookmark-alist' $B$N@_Dj(B"
  (let ((lst (or navi2ch-bookmark-list
		 (navi2ch-load-info navi2ch-bookmark-file)))
	(ignore-lst (delq nil (my-navi2ch-patrol-make-ignore-bookmark)))
	(rtn (unless target my-navi2ch-article-info-global-bookmark-alist))
	id)
    (when target
      (let (tmp)
	(unless (listp target)
	  (setq target (list target)))
	(while target
	  (setq tmp (cons (assoc (car target) lst) tmp)
		target (cdr target)))
	(setq lst tmp)))
    (while (setq id (car (car lst)))
      (unless (member id ignore-lst)
	(let ((bm-lst (cdr (cdr (car lst))))
	      arg)
	  (while (setq arg (car bm-lst))
	    (let* ((id (cdr (assoc 'id (assoc 'board arg))))
		   (artid (assoc 'artid (assoc 'article arg)))
		   (slot (assoc id rtn)))
	      (if (not slot)
		  (setq rtn (cons `(,id (total) (,artid)) rtn))
		(unless
		    (member artid
			    (mapcar (lambda (x)
				      (when (listp (cdr x))
;;;					(let ((tmp (assoc 'update x)))
;;;					  (when tmp (setcdr tmp nil)))
					(let ((tmp (assoc 'position x)))
					  (setcdr x (if tmp (list tmp) nil)))
					(assoc 'artid x)))
				    (cdr slot)))
		  (setcdr (cdr slot) (cons (list artid) (cdr (cdr slot)))))))
	    (setq bm-lst (cdr bm-lst)))))
      (setq lst (cdr lst)))
    rtn))

(defun my-navi2ch-patrol-put-alist (arg key val)
  "alist $B$r@_Dj$9$k(B"
  (if (assoc key arg)
      (setcdr (assoc key arg) val)
    (setcdr arg (cons (cons key val) (cdr arg)))))

(defun my-navi2ch-patrol-get-position (id subject-list)
  (let ((total (length subject-list))
	(pos (length (member (assoc id subject-list) subject-list))))
    (if (not pos) nil (- (1+ total) pos))))

(defun my-navi2ch-patrol-update-global-bookmark-alist ()
  "`my-navi2ch-article-info-global-bookmark-alist' $B$N99?7(B"
  (interactive)
  (or my-navi2ch-article-info-global-bookmark-alist
      (setq my-navi2ch-article-info-global-bookmark-alist
	    (my-navi2ch-patrol-global-bookmark-alist-setup)))
  (when (and (eq major-mode 'navi2ch-board-mode)
	     (not navi2ch-offline))
    (let* ((board
	    (cdr (assoc 'id
			(navi2ch-bm-get-board-internal
			 (navi2ch-bm-get-property-internal (point))))))
	   (data-list (assoc board
			     my-navi2ch-article-info-global-bookmark-alist))
	   (article-list (cdr (cdr data-list))))
      (when article-list
	(let ((total (assoc 'total data-list)))
	  (when total
	    (setcdr total (length navi2ch-board-subject-list))))
	(let ((subject-list navi2ch-board-subject-alist))
	  (mapcar
	   (lambda (x)
	     (let* ((id (cdr (assoc 'artid x)))
		    (tmp (cdr (assoc id subject-list)))
		    (res (if (stringp tmp)
			     (string-to-number tmp)
			   tmp)))
	       (when id
		 (if res
		     ;; $BHD$KM-$k(B
		     (let* ((tmp
			     (cdr
			      (assoc 'response
				     (my-navi2ch-article-info-get-info x))))
			    (response
			     (if (stringp tmp)
				 (string-to-number tmp)
			       tmp))
			    (update (and response (<= res response)))
			    (position
			     (my-navi2ch-patrol-get-position
			      id subject-list)))
		       (my-navi2ch-patrol-put-alist x 'update update)
		       (my-navi2ch-patrol-put-alist x 'position position))
		   ;; $BHD$KB8:_$7$J$$(B
		   (my-navi2ch-article-info-set-info x 'moved t)
		   ;; 				   (when my-navi2ch-compr-auto-compress-p
		   ;; 					 (let* ((board (navi2ch-bm-get-board-internal x))
		   ;; 							(article (navi2ch-bm-get-article-internal x))
		   ;; 							(file (navi2ch-article-get-file-name
		   ;; 								   board article)))
		   ;; 					   (unless (string-match "\\.gz\\'" file)
		   ;; 						 (my-navi2ch-compr-compressed-file file))))
		   (when (fboundp 'my-navi2ch-compr-auto-compress-article)
		     (funcall 'my-navi2ch-compr-auto-compress-article
			      'moved nil
			      (navi2ch-article-get-file-name
			       (navi2ch-bm-get-board-internal x)
			       (navi2ch-bm-get-article-internal x))))
		   (my-navi2ch-patrol-put-alist x 'position nil)
		   (my-navi2ch-patrol-put-alist x 'update 'unfind)))))
	   article-list))))))

(defun my-navi2ch-patrol-bookmark-add-subr (bookmark-id board article)
  (unless (assoc bookmark-id navi2ch-bookmark-list)
    (navi2ch-bookmark-create-bookmark bookmark-id))
  (let ((bookmark (assoc bookmark-id navi2ch-bookmark-list)))
    (setcdr (cdr bookmark)
	    (navi2ch-put-alist
	     (navi2ch-bookmark-get-key board article)
	     (list (cons 'board board)
		   (cons 'article article))
	     (cdr (cdr bookmark)))))
  (setq my-navi2ch-patrol-bookmark-save-info-p t))

(defun my-navi2ch-patrol-error-host-list-set (url)
  "URL $B$N%[%9%H$r(B `my-navi2ch-patrol-error-host-list' $B$KDI2C$9$k(B"
  (let ((host (and (stringp url) (navi2ch-url-to-host url))))
    (when host
      (let ((slot (assoc host my-navi2ch-patrol-error-host-list)))
	(if slot
	    (setcdr slot (1+ (cdr slot)))
	  (setq my-navi2ch-patrol-error-host-list
		(cons `(,host . 1) my-navi2ch-patrol-error-host-list)))))))

(defun my-navi2ch-patrol-error-host-list-reset (url)
  "URL $B$N%[%9%H$N%(%i!<2s?t$r%/%j%"$9$k(B"
  (let ((host (and (stringp url) (navi2ch-url-to-host url))))
    (when host
      (let ((slot (assoc host my-navi2ch-patrol-error-host-list)))
	(when slot
	  (setcdr slot 0))))))

(defun my-navi2ch-patrol-initialize ()
  "my-navi2ch-patrol $B$N(B advice $B4XO"$N=i4|=hM}(B"
  ;; advice $B$N3h@-(B
  (ad-enable-advice 'navi2ch-net-send-request
		    'around 'my-navi2ch-patrol-error-handler)
  (ad-activate 'navi2ch-net-send-request)
  (ad-enable-advice 'navi2ch-bm-fetch-article
		    'around 'my-navi2ch-patrol-check-url)
  (ad-activate 'navi2ch-bm-fetch-article)
  ;; advise $B$rIT3h@-(B
  (ad-disable-advice 'navi2ch-bookmark-fetch-mark-article
		     'around 'skip-unconnect-host)
  (ad-activate 'navi2ch-bookmark-fetch-mark-article)
  (ad-disable-advice 'navi2ch-bm-fetch-mark-article
		     'around 'skip-unconnect-host)
  (ad-activate 'navi2ch-bm-fetch-mark-article))

(defun my-navi2ch-patrol-finalize ()
  "my-navi2ch-patrol $B$N(B advice $B4XO"$N=*N;=hM}(B"
  ;; advice $B$rIT3h@-(B
  (ad-disable-advice 'navi2ch-net-send-request
		     'around 'my-navi2ch-patrol-error-handler)
  (ad-activate 'navi2ch-net-send-request)
  (ad-disable-advice 'navi2ch-bm-fetch-article
		     'around 'my-navi2ch-patrol-check-url)
  (ad-activate 'navi2ch-bm-fetch-article)
  ;; advice $B$N3h@-(B
  (ad-enable-advice 'navi2ch-bookmark-fetch-mark-article
		    'around 'skip-unconnect-host)
  (ad-activate 'navi2ch-bookmark-fetch-mark-article)
  (ad-enable-advice 'navi2ch-bm-fetch-mark-article
		    'around 'skip-unconnect-host)
  (ad-activate 'navi2ch-bm-fetch-mark-article))

(defun my-navi2ch-patrol (target)
  "$B<+F0$G%9%l$r99?7$9$k!#(B
$B0z?t$r;XDj$7$F<B9T$7$?>l9g$O(B mini-buffer $B$+$iF~NO$5$l$?(B bookmark $B$N$_$r(B
$B99?7$9$k!#(B"
  (interactive "P")
  (unless navi2ch-offline		; nil
    (and (listp target) (numberp (car target))
	 (setq target (my-navi2ch-patrol-read-bookmark-id)))
    (navi2ch-list-sync)	;; $BHD>pJs$N99?7(B
    (setq my-navi2ch-article-info-global-bookmark-alist
	  (my-navi2ch-patrol-global-bookmark-alist-setup))

    (let ((patrol-alist (my-navi2ch-patrol-make-alist target))
	  (board-list (mapcar (lambda (x) (cons (cdr (assq 'id x)) x))
			      navi2ch-list-board-name-list))
	  slot board handling bl)
      (unwind-protect
	  (progn
	    ;; list $B$N%/%j%"(B
	    (setq my-navi2ch-patrol-error-host-list nil)
	    ;; advice $B$N=i4|2=(B
	    (my-navi2ch-patrol-initialize)
	    ;; $B<+F0=d2s(B main
	    (my-navi2ch-patrol-trim-new-article
	     (my-navi2ch-patrol-main patrol-alist)))
	;; advice $B$r(B default $B$N@_Dj$KLa$9(B
	(my-navi2ch-patrol-finalize))
      ;; $B99?7$7$?%9%l$NEPO?(B
      (my-navi2ch-patrol-add-bookmark-update-articles)
      ;; bookmark $B$NJ]B8(B
      (if my-navi2ch-patrol-bookmark-save-info-p
	  (navi2ch-bookmark-save-info))
      (setq my-navi2ch-patrol-bookmark-save-info-p nil)
      ;; $B99?7MQ(B bookmark $B$X0\F0(B
      (when (and (not (and (interactive-p) target))
		 my-navi2ch-patrol-goto-update-articles-bookmark-p)
	(navi2ch-bookmark-goto-bookmark
	 my-navi2ch-patrol-update-articles-id))
      ;; $B=*N;(B hook
      (run-hooks 'my-navi2ch-patrol-after-hook))))

(defun my-navi2ch-patrol-main (patrol-alist)
  "$B<+F0=d2s$r9T$&(B"
  (let ((board-list (mapcar (lambda (x) (cons (cdr (assq 'id x)) x))
			    navi2ch-list-board-name-list))
	handling bmk-lst)

    (while patrol-alist
      (let* ((slot (car patrol-alist))
	     (board (if (car (cdr (assoc 'ignore slot)))
			nil
		      (cdr (assoc (car slot) board-list)))))
	(when board
	  (navi2ch-list-select-board board)
	  ;; == debug $BMQ(B ==
	  (when (eq (cdr (assq 'type board)) 'board)
	    (setq my-navi2ch-patrol-checked-board-list
		  (cons (cdr (assq 'name board))
			my-navi2ch-patrol-checked-board-list)))
	  ;; ==============
	  ;; handling $B$,$"$l$P=hM}$r$9$k!#(B
	  (and (setq handling (car (cdr (assoc 'handling slot))))
	       (funcall handling))

	  (let ((bookmark
		 (my-navi2ch-patrol-add-bookmark-new-articles
		  (car (cdr (assoc 'new-article slot))))))
	    (or (member bookmark bmk-lst)
		(setq bmk-lst (cons bookmark bmk-lst)))
	    (let ((slot (member (assoc bookmark patrol-alist) patrol-alist)))
	      (and slot (setcdr slot (cdr slot))))))
	(setq patrol-alist (cdr patrol-alist))))
    bmk-lst))


;;; advice $B$N@_Dj(B

(defvar my-navi2ch-patrol-check-time-list nil
  "debug $BMQ(B")
(defadvice navi2ch-board-sync (around update-check activate)
  (let ((check-time
	 (cdr (assoc 'time navi2ch-board-current-board))))
    ad-do-it
    ;; debug-start
    (setq my-navi2ch-patrol-check-time-list
	  (cons (list (cdr (assoc 'name navi2ch-board-current-board))
		      check-time
		      (cdr (assoc 'time navi2ch-board-current-board)))
		my-navi2ch-patrol-check-time-list))
    ;; debug-end
    (unless (equal check-time
		   (cdr (assoc 'time navi2ch-board-current-board)))
      ;; $BF|IU$,99?7$5$l$F$$$l$P!"(B
      ;; my-navi2ch-article-info-global-bookmark-alist $B$r99?7(B
      (my-navi2ch-patrol-update-global-bookmark-alist))))

;; $B@\B3$K<:GT$7$?>l9g!"$=$N%[%9%H$r(B my-navi2ch-patrol-error-host-list $B$KDI2C(B
(defadvice navi2ch-net-send-request
  (around my-navi2ch-patrol-error-handler disable)
  (let ((url_tmp (ad-get-arg 0)))
    (condition-case my-error-handle-trap
	(prog1
	    ad-do-it
	  (my-navi2ch-patrol-error-host-list-reset url_tmp))
      (error
       (my-navi2ch-patrol-error-host-list-set url_tmp)
       (signal (car my-error-handle-trap) (cdr my-error-handle-trap))))))

;;; $B0lDj2s?t0J>e%(%i!<$N@8$8$?%[%9%H$O%9%-%C%W$9$k(B
;; (defadvice navi2ch-bookmark-fetch-article
(defadvice navi2ch-bm-fetch-article
  (around my-navi2ch-patrol-check-url disable)
  (let* ((url (navi2ch-board-to-url
	       (navi2ch-bm-get-board-internal
		(navi2ch-bm-get-property-internal (point)))))
	 (host (and (stringp url) (navi2ch-url-to-host url))))
    (let ((cnt (cdr (assoc host my-navi2ch-patrol-error-host-list))))
      (if (not (and (numberp cnt)
		    (>= cnt my-navi2ch-patrol-error-host-retry-max)))
	  ad-do-it
	(navi2ch-bm-unmark)
	(let ((message-log-max nil))
	  (message "Cancel!!"))))))

;;; $B0lDj2s?t0J>e%(%i!<$N@8$8$?%[%9%H$O%9%-%C%W$9$k(B
(defadvice navi2ch-bookmark-fetch-mark-article
  (around skip-unconnect-host activate)
  (unwind-protect
      (progn
	(setq my-navi2ch-patrol-error-host-list nil)
	;; advice $B$N3h@-(B
	(ad-enable-advice 'navi2ch-net-send-request
			  'around 'my-navi2ch-patrol-error-handler)
	(ad-activate 'navi2ch-net-send-request)
	(ad-enable-advice 'navi2ch-bm-fetch-article
			  'around 'my-navi2ch-patrol-check-url)
	(ad-activate 'navi2ch-bm-fetch-article)
	ad-do-it)
    ;; advice $B$rIT3h@-(B
    (ad-disable-advice 'navi2ch-net-send-request
		       'around 'my-navi2ch-patrol-error-handler)
    (ad-activate 'navi2ch-net-send-request)
    (ad-disable-advice 'navi2ch-bm-fetch-article
		       'around 'my-navi2ch-patrol-check-url)
    (ad-activate 'navi2ch-bm-fetch-article)))

;;; $B0lDj2s?t0J>e%(%i!<$N@8$8$?%[%9%H$O%9%-%C%W$9$k(B
(defadvice navi2ch-bm-fetch-mark-article
  (around skip-unconnect-host activate)
  (unwind-protect
      (progn
	(setq my-navi2ch-patrol-error-host-list nil)
	;; advice $B$N3h@-(B
	(ad-enable-advice 'navi2ch-net-send-request
			  'around 'my-navi2ch-patrol-error-handler)
	(ad-activate 'navi2ch-net-send-request)
	(ad-enable-advice 'navi2ch-bm-fetch-article
			  'around 'my-navi2ch-patrol-check-url)
	(ad-activate 'navi2ch-bm-fetch-article)
	ad-do-it)
    ;; advice $B$rIT3h@-(B
    (ad-disable-advice 'navi2ch-net-send-request
		       'around 'my-navi2ch-patrol-error-handler)
    (ad-activate 'navi2ch-net-send-request)
    (ad-disable-advice 'navi2ch-bm-fetch-article
		       'around 'my-navi2ch-patrol-check-url)
    (ad-activate 'navi2ch-bm-fetch-article)))

(provide 'my-navi2ch-patrol)
